/**
 * @type {{Spinner: any, animateTextLeft: (textEle: HTMLElement, text:string, fadeOut?: boolean) => void}}
 */
const Animations = require("open-Indesign/animations");
const wrapper = document.getElementById("loading-wrapper");
const textDiv = document.getElementById("info-loading-text");

class LoadingAnimation {
  loading = false;

  /**
   * @type {{startSpinner: (parent: HTMLElement, onComplete: () => void) => void, play: () => void, reset: () => void, setError: (err: string) => void, setProgress: (progress: number) => void, stop: () => void }}
   */
  spinner;

  constructor() {
    this.spinner = new Animations.Spinner();
    this.reset();
  }

  cancel() {
    this.loading = false;
    fade(wrapper);
    this.spinner.stop();
    // this.spinner = null;
    // this.spinner = new Animations.Spinner();
  }

  /**
   *
   * @param {string} msg
   * @returns
   */
  async play(msg) {
    if (this.loading) return;
    await unfade(wrapper);
    console.log("******************************** SPINNNER: ", this.spinner);
    this.spinner.play();
    Animations.animateTextLeft(textDiv, msg || "");
    this.loading = true;
  }

  error(err) {
    this.spinner.setError(err);
    Animations.animateTextLeft(textDiv, err, true);

    // setTimeout(() => {
    //   fade(wrapper);
    // }, 4800);
  }

  /**
   *
   * @param {string} msg
   */
  success(msg) {
    this.spinner.setProgress(100);
    Animations.animateTextLeft(textDiv, msg, true);

    // setTimeout(() => {
    //   fade(wrapper);
    // }, 4800);
  }

  /**
   *
   * @param {string} msg
   */
  async progress(msg) {
    Animations.animateTextLeft(textDiv, msg);
  }

  reset() {
    this.spinner.reset();

    this.spinner.startSpinner(wrapper, async () => {
      this.loading = false;
      await fade(wrapper);
      this.reset();
    });
  }
}
