/**
 *
 * @param {HTMLElement} element
 */
function fade(element) {
  return new Promise(function (resolve, reject) {
    element.style.opacity = "1";

    let op = 1; // initial opacity
    const timer = setInterval(function () {
      if (op <= 0.1) {
        element.style.display = "none";
        resolve();
        clearInterval(timer);
      }
      element.style.opacity = op.toString();
      element.style.filter = "alpha(opacity=" + op * 100 + ")";
      op -= op * 0.1;
    }, 20);
  });
}

/**
 *
 * @param {HTMLElement} element
 */
function unfade(element) {
  return new Promise(function (resolve, reject) {
    let op = 0.1; // initial opacity
    element.style.opacity = "0";
    element.style.display = "block";

    const timer = setInterval(function () {
      if (op >= 1) {
        clearInterval(timer);
        resolve();
      }
      element.style.opacity = op.toString();
      element.style.filter = "alpha(opacity=" + op * 100 + ")";
      op += op * 0.1;
    }, 10);
  });
}
